关闭

黑马程序员——JAVA异常

57人阅读 评论(0) 收藏 举报
分类:

  ——- android培训java培训、期待与您交流! ———-

异常概述

异常:就是程序在运行时出现的不正常情况。

异常由来:问题也是现实生活中一个具体的事物,也可以通过java的类的形式进行描述,并封装成对象。其实就是java对不正常情况进行描述后的对象体现。

对于问题的划分:严重的问题,非严重的问题。(类比癌症和感冒,不用处理严重问题Error)
+ 对于严重的,java通过Error进行描述。一般不编写针对性代码对其进行出来。

  • 对于非严重的,java通过Exception类进行描述。。可以使用针对性处理方式进行处理。

无论Error和Exception,都具有共性内容。比如:不正常的情况信息,引发原因等。

Throwable

|-Error

|-Exception

异常处理try catch

JAVA虚拟机异常处理机制:try尝试检测异常,并传给catch处理。如果没trycatch,jvm默认的异常处理机制,调用printstackTrace

throws 抛出异常

throws关键字声明功能可能出现异常.必须进行处理和抛出,提高安全性,否则编译错误。


int div(int a,int b) throws Exception {

        return a/b

    }



//主函数抛出异常给jvm默认处理机制,处理后程序结束

public static void main(String[]args) throws Exception

多异常处理

  1. 声明异常时,建议声明更为具体异常。

  2. 对方声明几个异常,就对应几个catch块。不要定义多余catch

自定义异常

当函数内部抛出throw异常对象,必须给对应处理动作。

要么内部处理,要么声明让调用者处理。一般情况下,函数内部出现异常,函数需要声明。

如何定义异常信息?


    int div(int a,int b) throws XException  {

        if(b<0) throw new XEception();

        return a/b

    }

    //因为父类已经将异常信息操作完成了,子类在构造时,将异常信息传给父类通过Super语句

    class XEception extends Exception{

    public XEception(String msg) {

        super(msg);

    }




继承Exception原因:只有throwable这个体系中的类和对象才可以用throws 和throw操作

throw throws区别

  1. throws定义在函数上,throw使用在函数内

  2. throws后面跟异常类,可以跟多个,用逗号隔开,throw后跟异常对象。

RuntimeException

如果在函数内抛出该异常,函数上可以不用声明,编译一样通过。

如果在函数上声明该异常,调用者可以不处理,编译一样通过。

之所以不用在函数声明,时因为不需要让调用者处理,当异常发生,希望程序停止,在运行时,出现无法继续运行的情况,希望停止后,对代码修改。

Object的wait()函数,throws InterruptedException,有3个异常,2个运行时异常,只throws一个异常


    int div(int a,int b) {

        if(b==0) throw new ArithmeticException("被零除了“);

        return a/b

    }

空指针异常 “name”.equals(string);//equals比较字符串是否相同

编译时异常,运行时异常。

finally

一定被执行的代码,通常用于关闭资源。只有一种情况,调用System.exit(0)JVM退出时,finally不会执行。

比如数据库关闭,因为连接数有限。


public void method() throws NoException {

    try {

        连接数据库;

        数据操作;

    } catch(SQLException e){

        对数据库进行异常处理;

        throw new Exception();//对外暴露对方能识别的问题:问题封装

    }finally{

        关闭数据库;

    }

}

catch处理异常,没有catch代表异常没有处理,如果该异常检测时异常,必须在函数声明

异常-覆盖中的特点

(子类的异常父类能处理)

  1. 子类在覆盖父类时,如果父类的方法抛出异常,子类覆盖的方法,只能抛出父类的异常或子类。或者不抛出异常。

  2. 如果父类抛出多个异常,子类覆盖方法时,只能抛出父类异常的子集。

  3. 如果父类和接口方法中没有异常抛出,子类在覆盖方法时不能抛出异常。如果子类发生异常,必须catch处理,绝对不能抛出。

异常-总结

自定义异常,按照java面向对象思想,使用异常描述问题,对问题进行对象封装。

异常体系的特点:异常体系中所有类已经建立的对象都有可抛性。也就是可以用throw和throws关键字操作。


class NoValueException extends RuntimeException {

    public NoValueException(String msg){

        super(msg);

    }

}

异常的好处:

  1. 问题封装

  2. 将正常流程代码和问题处理代码分离。

异常处理原则:

  1. 处理方式有2种:try or throws

  2. 调用到异常的功能时,抛出几个,处理几个。一个try对应多个catch

  3. 多个catch,父类catch在最下面

  4. catch内,需要定义针对性的处理方式,不要简单的printStackTrace,输出语句。也不要不写。

  5. 当捕获异常,本功能处理不了,可以继续在catch中抛出异常。


try {throw new AException()}catch(AException e) {throw e}

如果该异常处理不了,但不属于该功能出现的异常,可以将异常转换后,抛出和该功能相关的异常。或者异常可以处理,需要将异常产生的和本功能相关的问题提供出去,当调用者知道,并处理,也可以捕获异常处理后,转换新的异常。


try {throw new AException()}catch(AException e) {throw new BException}


0
0

查看评论
* 以上用户言论只代表其个人观点,不代表CSDN网站的观点或立场
    个人资料
    • 访问:216次
    • 积分:40
    • 等级:
    • 排名:千里之外
    • 原创:4篇
    • 转载:0篇
    • 译文:0篇
    • 评论:0条
    文章分类
    文章存档